#pragma once

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <string>
#include <cstdint>

class GLWindow
{
public:
  GLWindow(int width, int height, const std::string& title);
  ~GLWindow();

  bool Run();
  void Clear();
  void Present();

  void DrawTexture(const uint8_t* data, int width, int height);
  bool IsReleased(int key);
private:
  GLFWwindow* m_window;
  GLuint m_texture;
};