#pragma once


// Addition
#define INC(_n_)                                                               \
  ++_n_;                                                                       \
  r.F = ((_n_ == 0) << 7) |                                                    \
        (((_n_ & 0x0F) == 0) << 5) | (r.F & 0x10);

#define ADD(_n_)                                                               \
  r.F = (((r.A + _n_) % 256 == 0) << 7) |                                      \
        (((r.A & 0x0F) + (_n_ & 0x0F) > 0x0F) << 5) |                          \
        (((r.A + _n_) > 0xFF) << 4);                                           \
  r.A += _n_;

#define ADC(_n_)                                                               \
  b = ((r.F & 0x10) >> 4);   /* Save carry before overwriting flags */         \
  r.F = (((r.A + _n_ + b) % 256 == 0) << 7) |                                  \
        (((r.A & 0x0F) + (_n_ & 0x0F) + b > 0x0F) << 5) |                      \
        (((r.A + _n_ + b) > 0xFF) << 4);                                       \
  r.A += _n_ + b;


// Subtraction
#define DEC(_n_)                                                               \
  --_n_;                                                                       \
  r.F = ((_n_ == 0) << 7) | (1 << 6) |                                         \
        (((_n_ & 0x0F) == 0x0F) << 5) | (r.F & 0x10);

#define SUB(_n_)                                                               \
  r.F = ((r.A == _n_) << 7) | (1 << 6) |                                       \
        (((r.A & 0x0F) < (_n_ & 0x0F)) << 5) |                                 \
        ((r.A < _n_) << 4);                                                    \
  r.A -= _n_;

#define SBC(_n_)                                                               \
  b = ((r.F & 0x10) >> 4);   /* Save carry before overwriting flags */         \
  r.F = ((r.A == (_n_ + b) % 256) << 7) | (1 << 6) |                           \
        (((r.A & 0x0F) < (_n_ & 0x0F) + b) << 5) |                             \
        ((r.A < _n_ + b) << 4);                                                \
  r.A -= _n_ + b;
