#include "Timer.hpp"
#include "GameBoy.hpp"

Timer::Timer(GameBoy* gb)
  : m_gb(gb),
    m_cycleCount(0)
{
}

void Timer::cylce()
{
  // Increment DIV
  HardwareRegisters* r = m_gb->getRegisters();
  if(m_cycleCount % 64 == 0)
    ++r->DIV;

  // Increment TIMA
  if(r->TAC & 0x04)
  {
    uint16_t mod[] = {256, 4, 16, 64};
    if(m_cycleCount % mod[r->TAC & 0x03] == 0)
    {
      if(++r->TIMA == 0) // Overflow
      {
        r->TIMA = r->TMA;
        r->IF |= (1 << INTERRUPT_TIMER);
      }
    }
  }
  ++m_cycleCount;
}