#include "MemBC5.hpp"

int MemBC5::romNumber() const
{
  // extract 9 bits
  return (m_reg & 0x01FF);
}

int MemBC5::ramNumber() const
{
  // extract the 4 highest bits
  return ((m_reg & 0xF000) >> 12);
}

void MemBC5::controllWrite(GBPtr ptr, GBByte data)
{
  if(ptr < 0x1FFF)  // RAM enable
  {
    // writing to bit 9
    m_reg = (m_reg & 0xFDFF) | ((data & 0x0F) == 0x0A) << 9;
  }
  else if(ptr < 0x2FFF)
  {
    m_reg = (m_reg & 0xFF00) | data;
  }
  else if(ptr < 0x3FFF)
  {
    m_reg = (m_reg & 0xFEFF) | ((data & 0x01) << 8);
  }
  else if(ptr < 0x5FFF)
  {
    m_reg = (m_reg & 0x0FFF) | (data & 0x0F) << 16;
  }
}