#include "TestSuite.hpp"

#include "CartRidgeTest.hpp"

#include "../libs/InOutAlgo.hpp"

#include <iostream>

using namespace std;
using namespace ioa;

TestSuite::TestSuite() 
{
  m_tests.emplace_back(new CartRidgeTest);
}

void TestSuite::runTests() 
{
  cout << BG_PURPLE << "##### Starting Unit Tests #####" << C_RESET_BG << endl;

  int passed = 0;
  int count = 0;
  for(auto& ut : m_tests)
  {
    count++;
    cout << FG_YELLOW << "[" << count << "/" << m_tests.size() << "]" 
         << C_RESET_FG << " Now running Test for Unit " 
         << FG_BLUE << ut->unitName() << C_RESET_FG
         << ":" << endl;
    auto res = ut->test();

    auto color = (res.success() ? FG_GREEN : FG_RED);

    cout << endl << "# UnitTest passed " << color
         << "(" << res.passed << "/" << res.tests << ")" << C_RESET_FG
         << " sub tests: " << color << (res.success() ? "OK" : "ERROR")
         << C_RESET_FG << endl;
    cout << "------------------------------------------------------" << endl;
    if(res.success())
      passed++;
  }

  cout << BG_PURPLE << "#####  Test Results:  #####" << C_RESET_BG << endl;
  cout << "Passed " << FG_TURQUOISE << "(" << passed << "/" 
       << m_tests.size() << ")" << C_RESET_FG << " unit tests:" << endl;
  if(passed == m_tests.size())
    cout << FG_GREEN << "OK" << C_RESET_FG << endl;
  else
    cout << FG_RED << "ERROR" << C_RESET_FG << endl;
}