#pragma once

#include <string>


#define ENSURE(_cond_, _resout_)                                               \
    if(!(_cond_))                                                              \
    {                                                                          \
        cout << endl << "Failed to ensure: \"" << #_cond_ << "\""              \
             << " (" << __FILE__ << ":" << __LINE__ << ")";                    \
        (_resout_) = false;                                                    \
    }

struct TestResult
{
  int tests;
  int passed;
  int warnings;

  bool success()
  {
    return (passed == tests);
  }

  TestResult()
    : tests(0), passed(0), warnings(0)
  {}
};

class UnitTest
{
public:
  virtual ~UnitTest() {}

  virtual TestResult test() = 0;
  virtual std::string unitName() = 0;
};